#include	<yz/window.h>

#define		YZ_UITK_IMPLEMENTOR
#include	"uitk.h"

int	yzUIElementFocusable(generic_ui_element_t	*elem)
{
	if(!elem)return 0;
	return yzUITypeFocusable(UIE_TYPE(elem));
}

int	yzUITypeFocusable(int		type)
{
	ui_element_type_info	*ti;
	
	ti = yzUILookupTypeByNumber(type);
	if(ti)return ti->focusable;
	else return 0;
}

generic_ui_element_t	*yzUIGetFocus()
{
	return yzGetWindowData(YZ_UI_FOCUS);
}

int	yzUIFocusItem(generic_ui_element_t	*elem)
{
	generic_ui_element_t	*oldFocus;
	ui_element_type_info	*ti;
	
	if(!yzUIElementFocusable(elem))return -1;
	oldFocus = yzUIGetFocus();
	if(oldFocus)yzUIDefocusItem(oldFocus);
	yzPutWindowData(YZ_UI_FOCUS, elem);
	ti = yzUILookupTypeByNumber(UIE_TYPE(elem));
	// should tell the item's own handlers about it
	return 0;
}

int	yzUIDefocusItem(generic_ui_element_t	*elem)
{
	ui_element_type_info	*ti;
	
	if(!elem)return -1;
	ti = yzUILookupTypeByNumber(UIE_TYPE(elem));
	// should tell the item's own handlers about it
	return 0;
}
