#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	<yz/window.h>

#define		YZ_UITK_IMPLEMENTOR
#include	"uitk.h"

static int						numTypes = 0;
static ui_element_type_info		*types = 0;

ui_element_type_info	*yzUILookupType(char	*name)
{
	int	i;
	
	for(i=0;i<numTypes;i++)
		if(!strcmp(types[i].name, name))return &types[i];
	return 0;
}

ui_element_type_info	*yzUILookupTypeByNumber(int	tn)
{
	int	i;
	
	for(i=0;i<numTypes;i++)
		if(types[i].type == tn)return &types[i];
	return 0;
}

int	yzUIRegisterTypeInfo(ui_element_type_info	*ti)
{
	ui_element_type_info	*t;
	
	if(!ti)return -1;
	t = yzUILookupType(ti->name);
	if(t)
	{
		if(!memcmp(t, ti, sizeof(ui_element_type_info)))return t->type;
		else return 0;
	}
	else
	{
		numTypes++;
		types = realloc(types, sizeof(ui_element_type_info)*numTypes);
		t = &types[numTypes-1];
		*t = *ti;
		t->type = numTypes;
		ti->type = t->type;
		return t->type;
	}
}

int					yzUIAddToList(void	*ex)
{
	ui_element_list			*lst, *add;
	ui_element_type_info	*ti;
	
	if(!ex)return -1;
	ti = yzUILookupTypeByNumber(UIE_TYPE(ex));
	lst = yzUIGetList(ti->name);
	add = malloc(sizeof(ui_element_list));
	add->prev = 0;
	add->next = lst;
	add->e = ex;
	if(lst && lst->prev != 0)printf("list for %s ->prev = %p\n", ti->name, lst->prev);
	if(lst)lst->prev = add;
	yzUISetList(ti->name, add);
	if(!lst && ti->filter)yzAddEventFilter(ti->filter);
	return 0;
}

int					yzUIRemoveFromList(void	*ex)
{
	ui_element_list			*lst, *rem;
	ui_element_type_info	*ti;
	
	if(!ex)return -1;
	ti = yzUILookupTypeByNumber(UIE_TYPE(ex));
	lst = yzUIGetList(ti->name);
	if(lst && lst->prev != 0)printf("list for %s ->prev = %p\n", ti->name, lst->prev);
	rem = lst;
	while(rem && rem->e != ex)rem=rem->next;
	if(!rem)return -1;
	if(rem->next)rem->next->prev = rem->prev;
	if(rem->prev)rem->prev->next = rem->next;
	if(lst == rem)
	{
		yzUISetList(ti->name, lst->next);
		if(!lst->next && ti->filter)yzRemoveEventFilter(ti->filter);
	}
	free((void*)rem);
}

ui_element_list		*yzUIGetList(char	*name)
{
	char	key[256];
	
	sprintf(key, "yz/ui/%s/ex-list", name);
	return (ui_element_list*)yzGetWindowData(key);
}

void	yzUISetList(char	*name, ui_element_list	*lst)
{
	char	key[256];
	void	*old;
	
	sprintf(key, "yz/ui/%s/ex-list", name);
	yzPutWindowData(key, (void*)lst);
}
